/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.api.data;

import fr.cenra.rhomeo.api.process.Indicator;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * Abstract implementation of {@link Protocol}.
 *
 * @author Samuel Andrés (Geomatys)
 */
public abstract class AbstractProtocol implements Protocol {

    private final String name;
    private final String remarks;
    protected final Class<? extends Statement> dataType;
    protected final Set<ReferenceDescription> referenceTypes = new HashSet<>();

    @Autowired // Need all subclasses to be Spring components.
    protected List<Indicator> indicators;

    public AbstractProtocol(final String name, final String remarks, final Class<? extends Statement> dataType, final ReferenceDescription... referenceTypes){
        this.name = name;
        this.remarks = remarks;
        this.dataType = dataType;
        if (referenceTypes != null && referenceTypes.length > 0) {
            for (final ReferenceDescription referenceType : referenceTypes) {
                if (referenceType != null) {
                    this.referenceTypes.add(referenceType);
                }
            }
        }
    }

    @Override
    public Class<? extends Statement> getDataType() {
        return dataType;
    }

    @Override
    public Set<ReferenceDescription> getReferenceTypes() {
        return referenceTypes;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public Collection<String> getAlias() {
        return Collections.singleton(name);
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    /**
     * Default implementation checking at least one {@link Indicator} exists
     * referencing this {@link Protocol} instance and compatible with the given
     * {@link Site} zone type code.
     *
     * @param site
     * @return
     */
    @Override
    public boolean isCompatible(Site site) {
        if (site == null) {
            return false;
        }

        for(final Indicator indicator : indicators){
            if(indicator.getProtocol()==this && indicator.getZoneTypeCodes() != null
                    && indicator.getZoneTypeCodes().contains(site.getZoneType())) return true;
        }
        return false;
    }

    @Override
    public int compareTo(final Protocol p){
        return this.getName().compareTo(p.getName());
    }

    @Override
    public String toString() {
        return "AbstractProtocol{" + "name=" + name + ", remarks=" + remarks + '}';
    }

}
